// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_common_msgs:msg/ReturnCodeConstants.idl
// generated code does not contain a copyright notice
#include "rc_common_msgs/msg/detail/return_code_constants__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
rc_common_msgs__msg__ReturnCodeConstants__init(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rc_common_msgs__msg__ReturnCodeConstants__fini(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
rc_common_msgs__msg__ReturnCodeConstants__are_equal(const rc_common_msgs__msg__ReturnCodeConstants * lhs, const rc_common_msgs__msg__ReturnCodeConstants * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCodeConstants__copy(
  const rc_common_msgs__msg__ReturnCodeConstants * input,
  rc_common_msgs__msg__ReturnCodeConstants * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

rc_common_msgs__msg__ReturnCodeConstants *
rc_common_msgs__msg__ReturnCodeConstants__create()
{
  rc_common_msgs__msg__ReturnCodeConstants * msg = (rc_common_msgs__msg__ReturnCodeConstants *)malloc(sizeof(rc_common_msgs__msg__ReturnCodeConstants));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_common_msgs__msg__ReturnCodeConstants));
  bool success = rc_common_msgs__msg__ReturnCodeConstants__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_common_msgs__msg__ReturnCodeConstants__destroy(rc_common_msgs__msg__ReturnCodeConstants * msg)
{
  if (msg) {
    rc_common_msgs__msg__ReturnCodeConstants__fini(msg);
  }
  free(msg);
}


bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__init(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_common_msgs__msg__ReturnCodeConstants * data = NULL;
  if (size) {
    data = (rc_common_msgs__msg__ReturnCodeConstants *)calloc(size, sizeof(rc_common_msgs__msg__ReturnCodeConstants));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_common_msgs__msg__ReturnCodeConstants__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_common_msgs__msg__ReturnCodeConstants__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_common_msgs__msg__ReturnCodeConstants__Sequence__fini(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_common_msgs__msg__ReturnCodeConstants__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_common_msgs__msg__ReturnCodeConstants__Sequence *
rc_common_msgs__msg__ReturnCodeConstants__Sequence__create(size_t size)
{
  rc_common_msgs__msg__ReturnCodeConstants__Sequence * array = (rc_common_msgs__msg__ReturnCodeConstants__Sequence *)malloc(sizeof(rc_common_msgs__msg__ReturnCodeConstants__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_common_msgs__msg__ReturnCodeConstants__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_common_msgs__msg__ReturnCodeConstants__Sequence__destroy(rc_common_msgs__msg__ReturnCodeConstants__Sequence * array)
{
  if (array) {
    rc_common_msgs__msg__ReturnCodeConstants__Sequence__fini(array);
  }
  free(array);
}

bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__are_equal(const rc_common_msgs__msg__ReturnCodeConstants__Sequence * lhs, const rc_common_msgs__msg__ReturnCodeConstants__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCodeConstants__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_common_msgs__msg__ReturnCodeConstants__Sequence__copy(
  const rc_common_msgs__msg__ReturnCodeConstants__Sequence * input,
  rc_common_msgs__msg__ReturnCodeConstants__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_common_msgs__msg__ReturnCodeConstants);
    rc_common_msgs__msg__ReturnCodeConstants * data =
      (rc_common_msgs__msg__ReturnCodeConstants *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_common_msgs__msg__ReturnCodeConstants__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rc_common_msgs__msg__ReturnCodeConstants__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_common_msgs__msg__ReturnCodeConstants__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
